
internal void *
platform_memory_reserve(u64 size)
{
  void* result = mmap(0, size, PROT_NONE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0);
  return result;
}

#define PAGE_SIZE sysconf(_SC_PAGESIZE)

internal b8
platform_memory_commit(void *ptr, u64 size)
{
  void *page_aligned_ptr =
    (void *)(((uintptr_t)ptr + PAGE_SIZE - 1) & ~(PAGE_SIZE - 1));
  mprotect(page_aligned_ptr, size, PROT_READ|PROT_WRITE);
  return 1;

}

internal void
platform_memory_decommit(void *ptr, u64 size)
{
  madvise(ptr, size, MADV_DONTNEED);
  mprotect(ptr, size, PROT_NONE);
}

internal void
platform_memory_release(void *ptr, u64 size)
{
  munmap(ptr, size);
}
